package mffs.projectors;

import mffs.CoordinateList;

public class FFShapeExtender extends FFShape
{
    private final short facing;
    private final short ausrichtungx;
    private final short ausrichtungy;
    private final short ausrichtungz;
    private final int wide;
    private final int length;
    private final int distance;

    public FFShapeExtender(TileProjector var1, short var2, int var3, int var4, int var5, short var6, short var7, short var8)
    {
        super(var1);
        this.facing = var2;
        this.ausrichtungx = var6;
        this.ausrichtungy = var7;
        this.ausrichtungz = var8;
        this.wide = var3;
        this.length = var4;
        this.distance = var5;
    }

    public void getFieldBlocks(CoordinateList var1)
    {
        for (int var2 = 0; var2 <= this.wide; ++var2)
        {
            int var3 = this.ausrichtungx * var2;
            int var4 = this.ausrichtungy * var2;
            int var5 = this.ausrichtungz * var2;

            for (int var6 = 1; var6 <= this.length; ++var6)
            {
                switch (this.facing)
                {
                    case 0:
                        var4 = -var6 - this.distance;
                        break;

                    case 1:
                        var4 = var6 + this.distance;
                        break;

                    case 2:
                        var5 = -var6 - this.distance;
                        break;

                    case 3:
                        var5 = var6 + this.distance;
                        break;

                    case 4:
                        var3 = -var6 - this.distance;
                        break;

                    case 5:
                        var3 = var6 + this.distance;
                }

                var1.add(this.centX + var3, this.centY + var4, this.centZ + var5, 1);
            }
        }
    }

    public int getBlockMode(int var1, int var2, int var3)
    {
        var1 -= this.centX;
        var2 -= this.centY;
        var3 -= this.centZ;
        int var4;

        switch (this.facing)
        {
            case 0:
                var4 = -var2;
                var2 = 0;
                break;

            case 1:
                var4 = var2;
                var2 = 0;
                break;

            case 2:
                var4 = -var3;
                var3 = 0;
                break;

            case 3:
                var4 = var3;
                var3 = 0;
                break;

            case 4:
                var4 = -var1;
                var1 = 0;
                break;

            case 5:
                var4 = var1;
                var1 = 0;
                break;

            default:
                return 0;
        }

        if (var4 >= this.distance && var4 <= this.distance + this.length)
        {
            int var5 = -1;

            if (var5 == -1 && this.ausrichtungx != 0)
            {
                var5 = var1 / this.ausrichtungx;
            }

            if (var5 == -1 && this.ausrichtungy != 0)
            {
                var5 = var1 / this.ausrichtungy;
            }

            if (var5 == -1 && this.ausrichtungz != 0)
            {
                var5 = var1 / this.ausrichtungz;
            }

            return var5 >= 0 && var5 <= this.length ? (var1 * this.ausrichtungx != var5 ? 0 : (var2 * this.ausrichtungy != var5 ? 0 : (var3 * this.ausrichtungz != var5 ? 0 : 1))) : 0;
        }
        else
        {
            return 0;
        }
    }
}
